<HTML>
<HEAD>
<!-- This HTML file has been created by texi2html 1.54
     from suif1.texi on 28 April 1999 -->

<TITLE>The SUIF Version 1 Library - Type Features</TITLE>
<link href="suif1_61.html" rel=Next>
<link href="suif1_59.html" rel=Previous>
<link href="suif1_toc.html" rel=ToC>

</HEAD>
<BODY>
<p>Go to the <A HREF="suif1_1.html">first</A>, <A HREF="suif1_59.html">previous</A>, <A HREF="suif1_61.html">next</A>, <A HREF="suif1_113.html">last</A> section, <A HREF="suif1_toc.html">table of contents</A>.
<P><HR><P>


<H2><A NAME="SEC60" HREF="suif1_toc.html#TOC60">Features Shared By All Types</A></H2>

<P>
The base <CODE>type_node</CODE> class defines some common features of all
types.  This section describes the methods from this base class along
with some comments about conventions for using types.  Besides the
things covered here, each <CODE>type_node</CODE> contains an ID number that
uniquely identifies it within a particular context.  See section <A HREF="suif1_50.html#SEC50">Numbering Types and Symbols</A>.

</P>
<P>
<A NAME="IDX418"></A>
New types can be created as necessary, but once a type has been entered
in a symbol table it should generally not be changed.  This helps to
avoid duplicate types and to prevent unintended side effects when a type
is used in multiple places.  Instead, the <CODE>copy</CODE> method can be used
to get a new type that is the same as the existing type, except that it
does not copy annotations.  The copy can then be freely modified and
installed in a symbol table.  If necessary, annotations on the type can
be copied separately using the <CODE>copy_annotes</CODE> method.  See section <A HREF="suif1_83.html#SEC83">SUIF Objects</A>.

</P>
<P>
<A NAME="IDX419"></A>
When a type is entered in a symbol table, it automatically records a
pointer to that parent table.  Similarly, when the type is removed from
the symbol table, its parent pointer is cleared.  The <CODE>parent</CODE>
method retrieves this parent pointer.

</P>
<P>
<A NAME="IDX420"></A>
Each type has a <CODE>size</CODE> method that returns the number of bits used
to store values of that type.  (That is not very meaningful for function
types, so they always have a fixed size of zero.)  The size for a type
may or may not be set directly, depending on the type operator.  The
sizes for type nodes from each of the derived classes are described in
the appropriate sections below.

</P>
<P>
<A NAME="IDX421"></A>
Structures, unions, and enumerated types are all given names.  The
<CODE>is_named</CODE> method checks to see if a <CODE>type_node</CODE> is one of
these types.  The name of a type should be unique within the symbol
table where it is defined, but the type name space is separate from the
names for symbols.  Because the type names are automatically entered in
the lexicon (see section <A HREF="suif1_102.html#SEC102">Lexicon</A>) when the types are created, they can be
compared as pointers without doing string comparisons.

</P>
<P>
<A NAME="IDX422"></A>
More than one <CODE>type_node</CODE> can represent the same type.  That is,
types may be equivalent even if they are represented by different type
nodes.  Given that, the only reason to reuse existing types is to keep
the symbol tables from getting too big.  The <CODE>is_same</CODE> method is
provided to check if two types are equivalent, so that the symbol tables
can be kept to a reasonable size.  However, <CODE>is_same</CODE> is only
intended to help get rid of duplicates.  Because it assumes that
duplicate types are still perfectly legal, it may potentially return
false negatives to avoid the expense of comparing annotations on type
nodes <A NAME="DOCF5" HREF="suif1_foot.html#FOOT5">(5)</A>.  For named types, the <CODE>is_same</CODE> method assumes that all
type nodes are unique; it does not check for structural equivalence.  In
most cases, <CODE>is_same</CODE> need not be called directly.  Instead, the
symbol table <CODE>install_type</CODE> method (see section <A HREF="suif1_49.html#SEC49">Adding and Removing Entries</A>), which uses <CODE>is_same</CODE> to detect and avoid duplicate
types, is the recommended way to add new types to a symbol table.

</P>
<P>
<A NAME="IDX423"></A>
SUIF has its own definition of type compatibility.  Two types do not
need to be strictly equivalent to be compatible.  Besides the rules for
type equivalence, the following conditions define which types are
compatible:

</P>

<UL>
<LI>

Enumerated types and integers of the same size are compatible if they
are both signed or both unsigned.

<LI>

Any two pointer types are compatible.

<LI>

Type modifiers and annotations do not affect compatibility.
</UL>

<P>
The <CODE>compatible</CODE> method is included in the <CODE>type_node</CODE> class
to determine if two types are compatible according to these rules.

</P>
<P>
<A NAME="IDX424"></A>
<A NAME="IDX425"></A>
<A NAME="IDX426"></A>
There are three different methods for printing SUIF types.  The
<CODE>print_abbrev</CODE> method is used when printing the result types of
instructions.  It prints the type ID number along with a single
character to identify the type operator followed by a period and the
size (e.g.  <SAMP>`i.32'</SAMP> for a 32-bit integer).  The <CODE>print</CODE> method
shows the ID number prefixed with <SAMP>`t:'</SAMP> to identify it as a type.
The <CODE>print_full</CODE> method prints all of the type information and is
used when listing symbol tables.  It's optional <CODE>depth</CODE> parameter
can be used to specify the indentation level.

</P>
<P>
Many kinds of type nodes contain fields that refer to other types.
Moreover, each type may contain annotations that include references to
other types.  With one exception, however, recursive type references are
not allowed.  In other words, if the type nodes are viewed as a directed
graph with the references between them forming the edges, there can be
no cycles.  To support recursive data structures, we allow an exception
to this rule: types within a field of a structure or union may refer
back to the structure or union type.

</P>

<P><HR><P>
<p>Go to the <A HREF="suif1_1.html">first</A>, <A HREF="suif1_59.html">previous</A>, <A HREF="suif1_61.html">next</A>, <A HREF="suif1_113.html">last</A> section, <A HREF="suif1_toc.html">table of contents</A>.
</BODY>
</HTML>
